//+------------------------------------------------------------------+
//|                                     RK_MAD_Heiken Ashi MA T3.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//|                    Uses; RK-MAD-Heiken_Ashi_Ma_T3_new[Alert].mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//+------------------------------------------------------------------+
#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Ronald Raygun"

extern string Remark1           = "== Main Settings ==";

extern int    MagicNumber       = 2009;
extern bool   SignalsOnly       = False;
extern bool   Alerts            = True;
extern bool   SignalMail        = False;
extern bool   PlaySounds        = True;
extern bool   UseTimes          = False;
extern int    HourStart         = 8;
extern int    HourEnd           = 16;
extern bool   EachTickMode      = True;
extern double Lots              = 1.0;
extern bool   MoneyManagement   = False;
extern int    Risk              = 0;
extern int    Slippage          = 5;
extern  bool  UseStopLoss       = False;
extern int    StopLoss          = 20;
extern bool   UseTakeProfit     = False;
extern int    TakeProfit        = 0;
extern bool   UseTrailingStop   = False;
extern int    TrailingStop      = 0;
extern bool   MoveStopOnce      = False;
extern int    MoveStopWhenPrice = 0;
extern int    MoveStopTo        = 0;

extern string Remark3           = "";

extern string Remark2           = "== Heiken Ashi Ma T3 Settings ==";

extern int    TimeFrame         = 0;
extern int    MaPeriod          = 3;
extern int    MaMetod           = 1;
extern int    Step              = 1;
extern bool   BetterFormula     = false;
extern bool   T3Average         = true;
extern double T3Hot             = 0.618;
extern bool   T3Original        = false;

extern string Remark4           = "";

extern string Remark5           = "== Exit Settings ==";

extern bool   HeikenAshiExit    = True;

extern string Remark6           = "==Entry Settings ==";

extern int    Current           = 0;
extern bool   HAEntry           = True;



//Version 2.01

int BarCount;
int SignalsTaken;
double pointvalue;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {

   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = Current;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() 
{
  /*  
  static datetime Time.newbar;
   bool newbar = (Time[0] > Time.newbar); 
   if (newbar)  //A new bar begin.
   {
   Time.newbar =Time[0];                 //Reset static.
   //...
   }
  */
  
  
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

//Money Management sequence
 if (MoneyManagement)
   {
      if (Risk<1 || Risk>100)
      {
         Comment("Invalid Risk Value.");
         return(0);
      }
      else
      {
         Lots=MathFloor((AccountFreeMargin()*AccountLeverage()*Risk*pointvalue*100)/(Ask*MarketInfo(Symbol(),MODE_LOTSIZE)*MarketInfo(Symbol(),MODE_MINLOT)))*MarketInfo(Symbol(),MODE_MINLOT);
      }
   }

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+


double HAOpen =  iCustom(NULL,TimeFrame,"RK-MAD-Heiken_Ashi_Ma_T3_new[Alert]", MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Hot,T3Original,2,Current + 0);
double HAClose = iCustom(NULL,TimeFrame,"RK-MAD-Heiken_Ashi_Ma_T3_new[Alert]", MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Hot,T3Original,3,Current + 0);

double HAOpen2 = iCustom(NULL,TimeFrame,"RK-MAD-Heiken_Ashi_Ma_T3_new[Alert]", MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Hot,T3Original,2,Current + 1);
double HAClose2 =iCustom(NULL,TimeFrame,"RK-MAD-Heiken_Ashi_Ma_T3_new[Alert]", MaPeriod,MaMetod,Step,BetterFormula,T3Average,T3Hot,T3Original,3,Current + 1);

string HADirection = "None";
if(HAEntry && HAOpen < HAClose && HAOpen2 > HAClose2 )/* && Volume[0]==1)*/ HADirection = "Long";
if(HAEntry && HAOpen > HAClose && HAOpen2 < HAClose2 ) /* && Volume[0]==1)*/ HADirection = "Short";
if(!HAEntry) HADirection = "Not Used";



string TradingTime = "Outside Trading Times";
if(UseTimes && TimeHour(TimeCurrent()) >= HourStart && TimeHour(TimeCurrent()) < HourEnd) TradingTime = "Inside Trading Times";
if(!UseTimes) TradingTime = "Not Used";

string TradeTrigger = "None";
if(TradingTime != "Outside Trading Times" && (HADirection == "Long" || HADirection == "Not Used") && HAOpen2 > HAClose2 )/* && Volume[0]==1)*/ TradeTrigger = "Open Long";
if(TradingTime != "Outside Trading Times" && (HADirection == "Short" || HADirection == "Not Used") && HAOpen2 < HAClose2 )/* && Volume[0]==1)*/ TradeTrigger = "Open Short";




string CloseTrigger = "None";
if(HeikenAshiExit && HADirection == "Short") CloseTrigger = "Close Long";
if(HeikenAshiExit && HADirection == "Long") CloseTrigger = "Close Short";

Comment("Trading Times: ", TradingTime, "\n",       
        "Heiken Ashi Direction: ", HADirection, "\n",
        "Trade Trigger: ", TradeTrigger, "\n",
        "Close Trigger: ", CloseTrigger);
        
        
   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
         
            
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

if(CloseTrigger == "Close Long")Order = SIGNAL_CLOSEBUY;
  

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //MoveOnce
            if(MoveStopOnce && MoveStopWhenPrice > 0) {
               if(Bid - OrderOpenPrice() >= pointvalue * MoveStopWhenPrice) {
                  if(OrderStopLoss() < OrderOpenPrice() + pointvalue * MoveStopTo) {
                  OrderModify(OrderTicket(),OrderOpenPrice(), OrderOpenPrice() + pointvalue * MoveStopTo, OrderTakeProfit(), 0, Red);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > pointvalue * TrailingStop) {
                  if(OrderStopLoss() < Bid - pointvalue * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - pointvalue * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
        
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

if(CloseTrigger == "Close Short") Order = SIGNAL_CLOSESELL;

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //MoveOnce
            if(MoveStopOnce && MoveStopWhenPrice > 0) {
               if(OrderOpenPrice() - Ask >= pointvalue * MoveStopWhenPrice) {
                  if(OrderStopLoss() > OrderOpenPrice() - pointvalue * MoveStopTo) {
                  OrderModify(OrderTicket(),OrderOpenPrice(), OrderOpenPrice() - pointvalue * MoveStopTo, OrderTakeProfit(), 0, Red);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
            //Trailing stop
            if(UseTrailingStop && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (pointvalue * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + pointvalue * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + pointvalue * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

if(TradeTrigger == "Open Long") Order = SIGNAL_BUY;
if(TradeTrigger == "Open Short") Order = SIGNAL_SELL;

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(SignalsOnly && SignalsTaken != Bars) {
         SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + "Buy Signal");
         Alert("[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + "Buy Signal");
         PlaySound("alert.wav");
         SignalsTaken = Bars;
      }
      
      if(!IsTrade && !SignalsOnly) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Ask - StopLoss * pointvalue; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Ask + TakeProfit * pointvalue; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if(SignalsTaken != Bars) {
                  SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + "Buy Signal");
			         Alert("[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + "Buy Signal");
                  PlaySound("alert.wav");
                  SignalsTaken = Bars;
                  }
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(SignalsOnly && SignalsTaken != Bars) {
          SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + "Sell Signal");
          Alert("[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + "Sell Signal");
          PlaySound("alert.wav");
          SignalsTaken = Bars;
         }
      if(!IsTrade && !SignalsOnly) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (UseStopLoss) StopLossLevel = Bid + StopLoss * pointvalue; else StopLossLevel = 0.0;
         if (UseTakeProfit) TakeProfitLevel = Bid - TakeProfit * pointvalue; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
				Alert("[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + "Sell Signal");
				PlaySound("alert.wav");
				SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + "Sell Signal");
                
                if(SignalsTaken != Bars) {
                  
			       SignalsTaken = Bars;
                  }
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}